//+------------------------------------------------------------------+
#property copyright "Copyright  2011,"
#include <stdlib.mqh>

#define SIGNAL_NONE        0 
#define UP                 1 
#define DOWN               2
#define SIGNAL_BUY         3 
#define SIGNAL_SELL        4 
#define SIGNAL_CLOSEBUY    5
#define SIGNAL_CLOSESELL   6 

extern string    separator1 = "------trend settings------";
extern int       barsInTrend = 1;                  // how many bars should be in trend

extern string    separator1a = "------Trading Time settings------";
extern bool      AllowTradesByTime = false;         // Trading Time Allowed
extern int       Start_Time = 2;                   // Time to allow trading to start ( hours of 24 hr clock ) 0 for both disables
extern int       Finish_Time = 17;                 // Time to stop trading ( hours of 24 hr clock ) 0 for both disables

extern string    separator2 = "------position settings------";
extern double    Buylots = 0.01;                     // fixed lot size
extern double    Selllots = 0.01;                     // fixed lot size
extern int       BuymaxTrades = 1;                   // max trades allowed for pyramiding
extern int       SellmaxTrades = 1;                   // max trades allowed for pyramiding
extern double    stop_loss = 50;                   // stop loss
extern double    take_profitT = 200;                // take profit
extern double    take_profit = 50;                // take profit
extern bool      useTrailingStop = True;          // use trailing stop
extern double    trailing_stop = 35;               // trail stop loss
extern bool      useUnprofitExit = True;          // exit trade when trade was not in profit in defined amount of bars
extern int       maxUnprofitBars = 5;              // amount of bars not in profit
extern string    symb;
extern bool	PopupAlert        	= true;
extern bool SendPushNotification = false;
extern bool SoundAlert           = false;
extern string SoundFileLong      = "alert.wav";
extern string SoundFileShort     = "alert2.wav";
int lastAlert=3;
 
extern string    separator4 = "------Sleep settings------";
extern bool      useSleepAfterClosed = False;       // Put to sleep for 30 minit after closing order

extern double    magicNumber = 0;

double stopLoss, takeProfitT, takeProfit, trailingStop;

bool buyBE, sellBE;
bool TrendOpen, TrendClosed;
bool EntryBuy, EntrySell;

double signal_Buy1;
double signal_Buy2;
double signal_Buy3;
double signal_Sell1;
double signal_Sell2;
double signal_Sell3;

double minAllowedLot, lotStep, maxAllowedLot;

int unprofitBars=0;
int Order = SIGNAL_NONE;
int slipageOrder = 3, slipageClose = 5;

double pips2dbl;
datetime barTime=0;
static datetime barTimeM5; 

int flag, count;
bool dselect,dclosed,dmodify;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   Comment("Copyright  2011");
   
  
   if (Digits == 5 || Digits == 3)    // Adjust for five (5) digit brokers.
   {            
      pips2dbl = Point*10;
   } 
   else 
   {    
      pips2dbl = Point;   
   }
   
   stopLoss = pips2dbl*stop_loss;

   if (TrendOpen ==1 || TrendOpen == 2)
   takeProfitT = pips2dbl*take_profitT;
   else
   takeProfit = pips2dbl*take_profit;
   
   trailingStop = pips2dbl*trailing_stop;

/*   
   minAllowedLot  =  MarketInfo(Symbol(), MODE_MINLOT);    //IBFX= 0.10
   lotStep        =  MarketInfo(Symbol(), MODE_LOTSTEP);   //IBFX= 0.01
   maxAllowedLot  =  MarketInfo(Symbol(), MODE_MAXLOT );   //IBFX=50.00
   
   if(Selllots < minAllowedLot)
      Selllots = minAllowedLot;
   if(Buylots > maxAllowedLot)
      Buylots = maxAllowedLot;
*/

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   Comment ("");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()

{
//----
   if(IsNewBar())
   {
      if(IsProfitOnBar())
         unprofitBars=0;
      else
         unprofitBars++;
   }

   if(useTrailingStop)
      if(!TrailingStopCheck())
         return(0);
           
//-------------------------------------------
/*
datetime now = TimeCurrent(),
         tM5= now - now % 300;
if (barTimeM5 == tM5) return; barTimeM5 = tM5;
// start of a new M30 bar.
*/
//---------------------------------------------------------------------------------------++
// Get calculation for Main Pair
   string CondB1 = "", CondS1 = "";
   string CondB2 = "", CondS2 = "";
   string CondB3 = "", CondS3 = "";
   string CondB4 = "", CondS4 = "";
   string CondB5 = "", CondS5 = "";
   string CondB6 = "", CondS6 = "";
   string CondB7 = "", CondS7 = "";

   double EUR = iCustom(NULL,0,"#ConsoleFUW1 -TOT test",0,0);
   double GBP = iCustom(NULL,0,"#ConsoleFUW1 -TOT test",1,0);
   double USD = iCustom(NULL,0,"#ConsoleFUW1 -TOT test",2,0);
   double JPY = iCustom(NULL,0,"#ConsoleFUW1 -TOT test",3,0);
   double AUD = iCustom(NULL,0,"#ConsoleFUW1 -TOT test",4,0);
   double NZD = iCustom(NULL,0,"#ConsoleFUW1 -TOT test",5,0);
   double CAD = iCustom(NULL,0,"#ConsoleFUW1 -TOT test",6,0);


//-----------------------
// Calculate TRENDING FOR THE PAST 15 MINUTES --------------

         
///////////////////////////////VERIABLE BUY CONDITON ///////////////////////////////////////////////////////////////////

   
         if ((GBP > AUD))
         {
         //CloseOrderCheck("GBPAUD",Buylots, slipageOrder);
         CondB1 = "Condition 1 Buy OK";
         ManageBuy("GPBAUD",Buylots,takeProfitT,stopLoss,slipageOrder,magicNumber,"EA Console");
         }
         
         if ((GBP > NZD))
         {
         //CloseOrderCheck("GBPNZD",Buylots, slipageOrder);
         CondB2 = "Condition 2 Buy OK";
         ManageBuy("GPBNZD",Buylots,takeProfitT,stopLoss,slipageOrder,magicNumber,"EA Console");
         }
         
         if ((GBP > CAD))
         {
         //CloseOrderCheck("GBPCAD",Buylots, slipageOrder);
         CondB3 = "Condition 3 Buy OK";
         ManageBuy("GPBCAD",Buylots,takeProfitT,stopLoss,slipageOrder,magicNumber,"EA Console");
         }
         
         if ((EUR > AUD))
         {
         //CloseOrderCheck("EURAUD",Buylots, slipageOrder);
         CondB4 = "Condition 4 Buy OK";
         ManageBuy("EURAUD",Buylots,takeProfitT,stopLoss,slipageOrder,magicNumber,"EA Console");
         }
         
         if ((EUR > NZD))
         {
         //CloseOrderCheck("EURNZD",Buylots, slipageOrder);
         CondB5 = "Condition 5 Buy OK";
         ManageBuy("EURNZD",Buylots,takeProfitT,stopLoss,slipageOrder,magicNumber,"EA Console");
         }
         
         if ((EUR > CAD))
         {
         //CloseOrderCheck("EURCAD",Buylots, slipageOrder);
         CondB6 = "Condition 6 Buy OK";
         ManageBuy("EURCAD",Buylots,takeProfitT,stopLoss,slipageOrder,magicNumber,"EA Console");
         }
///////////////////////////////VERIABLE SELL CONDITON ///////////////////////////////////////////////////////////////////

         if ((GBP < AUD))
         //CloseOrderCheck("GBPAUD",Buylots, slipageOrder);
         CondS1 = "Condition 1 Sell OK";
         ManageSell("GPBAUD",Buylots,takeProfitT,stopLoss,slipageOrder,magicNumber,"EA Console");

         if ((GBP < NZD))
         //CloseOrderCheck("GPBNZD",Buylots, slipageOrder);
         CondS2 = "Condition 2 Sell OK";
         ManageSell("GPBNZD",Buylots,takeProfitT,stopLoss,slipageOrder,magicNumber,"EA Console");

         if ((GBP < CAD))
         //CloseOrderCheck("GPBCAD",Buylots, slipageOrder);
         CondS3 = "Condition 3 Sell OK";
         ManageSell("GPBCAD",Buylots,takeProfitT,stopLoss,slipageOrder,magicNumber,"EA Console");
//------------------
         if ((EUR < AUD))
         //CloseOrderCheck("EURAUD",Buylots, slipageOrder);
         CondS4 = "Condition 4 Sell OK";
         ManageSell("EURAUD",Buylots,takeProfitT,stopLoss,slipageOrder,magicNumber,"EA Console");

         if ((EUR < NZD))
         //CloseOrderCheck("EURNZD",Buylots, slipageOrder);
         CondS5 = "Condition 5 Sell OK";
         ManageSell("EURNZD",Buylots,takeProfitT,stopLoss,slipageOrder,magicNumber,"EA Console");

         if ((EUR < CAD))
         //CloseOrderCheck("EURCAD",Buylots, slipageOrder);
         CondS6 = "Condition 6 Sell OK";
         ManageSell("EURCAD",Buylots,takeProfitT,stopLoss,slipageOrder,magicNumber,"EA Console");

//=================================================================================================

   Comment (CondB1 + "         " + CondB2 + "          " + CondB3 + "            " +
            CondB4 + "         " + CondB5 + "          " + CondB6 + "            " +
            CondS1 + "         " + CondS2 + "          " + CondS3 + "            " +
            CondS4 + "         " + CondS5 + "          " + CondS6 + "            " 
            );
//----
   return(0);
}


//////////////////////////////////////////////////////////////////////////////////////////////////  

//bool CloseOrderCheck()
void CloseOrderCheck(string symb,double lt, int slp)

{

    double ask   =MarketInfo(symb,MODE_ASK);
    double bid   =MarketInfo(symb,MODE_BID);

   int total=OpenTradesForMNandPairType(magicNumber, symb);
   for(int cnt=total-1;cnt>=0;cnt--)
    {
      dselect = OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(   OrderType()<=OP_SELL                      // check for opened position 
         && OrderSymbol()==symb                   // check for symbol
         && (OrderMagicNumber() == magicNumber||OrderMagicNumber() == 0))        //  my magic number  && manual trades

      {
         if(OrderType()==OP_BUY)   // long position is opened
         {
            // should it be closed?                       
            if (Order == SIGNAL_CLOSEBUY)
            {
               if(OrderClose(OrderTicket(),OrderLots(),bid,slipageClose,Violet)) // close position
               {
               Alert("X 1-CloseBuy order : ", OrderSymbol(), OrderClosePrice());
               Alert (GetLastError());                      // Error message
               PlaySound("work.wav") ;
                  //return (true);
               }
               //return(false);
            } 
         }
         else // go to short position
         {
            // should it be closed?        
            if(Order == SIGNAL_CLOSESELL)
            {
               if(OrderClose(OrderTicket(),OrderLots(),ask,slipageClose,Violet)) // close position
               {
               Alert("X 1-CloseSell order : ",  OrderSymbol(), OrderClosePrice());
               Alert (GetLastError());                      // Error message
                PlaySound("work.wav") ;
                  //return (true);  
               }
               //return(false);
            }          
         }
      }
   }
   //return (true);
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//bool OpenOrderCheck()

void ManageBuy(string symb,double lt,double TP,double SL,int slp,int magic,string com)
{
    double ask   =MarketInfo(symb,MODE_ASK);
    double bid   =MarketInfo(symb,MODE_BID);
    double point =MarketInfo(symb,MODE_POINT);
    double sprd  =MarketInfo(symb,MODE_SPREAD);

   int ticket;
   int total=OpenTradesForMNandPairType(magicNumber, symb);
   
   if(total<BuymaxTrades)
   {
      // check for long position (BUY) possibility
      if(Order == SIGNAL_BUY)
      {
         if (TrendOpen ==1)
         ticket=OrderSend(symb,OP_BUY,Buylots,ask,slipageOrder, ask-stopLoss,ask+takeProfitT,"EA Console",magicNumber,0,Green);
         else
         ticket=OrderSend(symb,OP_BUY,Buylots,ask,slipageOrder, ask-stopLoss,ask+takeProfit,"EA Console",magicNumber,0,Green);
         if(ticket>0)
         {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) 
            {
             //  buyBE=0;
               PlaySound("ok.wav") ;
               Alert("X 1-BUY order opened : ", OrderSymbol(),OrderOpenPrice());
               Alert (GetLastError());                      // Error message
              // return (true);
            }
         }
         else 
         {
         if((OrderSend(symb,OP_BUY,Buylots,ask,slipageOrder, ask-stopLoss,ask+takeProfitT,"EA Console",magicNumber,0,Green) < 0) 
         || (OrderSend(symb,OP_BUY,Buylots,ask,slipageOrder, ask-stopLoss,ask+takeProfit,"EA Console",magicNumber,0,Green) < 0)) 
         Alert("Error opening position # ", GetLastError());
        // return(0);
//         Alert("Error opening BUY order : ",GetLastError());   
//         return(false);
         }   
      }
    }
}
//-----------------------------------------------------------------------------------------------------------------------
void ManageSell(string symb,double lt,double TP,double SL,int slp,int magic,string com)
{
    double ask   =MarketInfo(symb,MODE_ASK);
    double bid   =MarketInfo(symb,MODE_BID);
    double point =MarketInfo(symb,MODE_POINT);
    double sprd  =MarketInfo(symb,MODE_SPREAD);

   int ticket;
   int total=OpenTradesForMNandPairType(magicNumber, symb);

   if(total<SellmaxTrades)
   {
      // check for short position (SELL) possibility
      if(Order == SIGNAL_SELL)
      {
         if (TrendOpen ==2)
         ticket=OrderSend(symb,OP_SELL,Selllots,bid,slipageOrder, bid+stopLoss,bid-takeProfitT,"EA Console",magicNumber,0,Red);
         else
         ticket=OrderSend(symb,OP_SELL,Selllots,bid,slipageOrder, bid+stopLoss,bid-takeProfit,"EA Console",magicNumber,0,Red);
         if(ticket>0)
         {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
            { 
             //  sellBE=0;
               PlaySound("ok.wav") ;
               Alert("X 1-SELL order opened : ",OrderSymbol(), OrderOpenPrice());
               Alert (GetLastError());                      // Error message
               //return (true);
            }
         }
         else
         {
         if ((OrderSend(symb,OP_SELL,Selllots,bid,slipageOrder, bid+stopLoss,bid-takeProfitT,"EA Console",magicNumber,0,Red)<0) 
         || (OrderSend(symb,OP_SELL,Selllots,bid,slipageOrder, bid+stopLoss,bid-takeProfit,"EA Console",magicNumber,0,Red)<0) )
         Alert("Error opening SELL order : ",GetLastError());
         //return (0); 
         } //return (false);
      }
   }
   //return (true);   
}

//////////////////////////////////////////////////////////////////////////////////////////////////
bool TrailingStopCheck()
{  
   double newStopLoss;
   int total=OrdersTotal();
   for(int cnt=total-1;cnt>=0;cnt--)
   {
      dselect = OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(   OrderType()<=OP_SELL                      // check for opened position 
         && OrderSymbol()==symb                   // check for symbol
         && OrderMagicNumber() == magicNumber)        // my magic number
      {
         if(OrderType()==OP_BUY)   // long position is opened
         {
            // should it be modified? 
            newStopLoss = TrailingStopBuy();                      
            if(newStopLoss > 0)
            {
               if(OrderModify(OrderTicket(),OrderOpenPrice(),newStopLoss,OrderTakeProfit(),0,Green)) // modify position
               {
                   PlaySound("work.wav") ;
                   return (true);
               }
               return(false);
            } 
         }
         else // go to short position
         {
            // should it be modified? 
            newStopLoss = TrailingStopSell();        
            if(newStopLoss > 0)
            {
               if(OrderModify(OrderTicket(),OrderOpenPrice(),newStopLoss,OrderTakeProfit(),0,Green)) // modify position
               {
                  PlaySound("work.wav") ;
                  return (true);
               }
               return(false);
            }          
         }
      }
   }
   return (true);
}

//////////////////////////////////////////////////////////////////////////////////////////////////
double TrailingStopBuy()
{
   double newStopLoss;
   double ask   =MarketInfo(symb,MODE_ASK);

   newStopLoss=ask-stopLoss;
   if((newStopLoss-trailingStop)>OrderStopLoss())
      return (newStopLoss);
   return (0);
}

//////////////////////////////////////////////////////////////////////////////////////////////////
double TrailingStopSell()
{
   double newStopLoss;
   double bid   =MarketInfo(symb,MODE_BID);
   
   newStopLoss=bid+stopLoss;
   if((newStopLoss+trailingStop)<OrderStopLoss())
      return (newStopLoss);

   return (0);
}

//////////////////////////////////////////////////////////////////////////////////////////////////
int OpenTradesForMNandPairType(int iMN, string symb)
{
   int icnt, itotal, retval;

   retval=0;
   itotal=OrdersTotal();

      for(icnt=itotal-1;icnt>=0;icnt--) // for loop
      {
         dselect = OrderSelect(icnt, SELECT_BY_POS, MODE_TRADES);
         // check for opened position, symbol & MagicNumber
         if (OrderSymbol()== symb)
         {
            if (OrderMagicNumber()==iMN) 
               retval++;             
         } // sOrderSymbol
      } // for loop

   return(retval);
}

///////////////////////////////////////////////////////////////////////////////////////////////////



bool IsNewBar()
{
   if( barTime < Time[0]) 
   {
        // we have a new bar opened
      barTime = Time[0];
      return(true);
   }
   return (false);
}

///////////////////////////////////////////////////////////////////////////////////////////////////
bool IsProfitOnBar()
{
   int icnt, itotal;
   itotal=OrdersTotal();
   if(itotal==0)
      return(true);
      
   for(icnt=itotal-1;icnt>=0;icnt--) // for loop
   {
      dselect = OrderSelect(icnt, SELECT_BY_POS, MODE_TRADES);
      // check for opened position, symbol & MagicNumber
      if (OrderSymbol()== symb && OrderMagicNumber()==magicNumber)
      {
         if (OrderProfit()>0) 
            return(true);             
      } 
   } // for loop 
   return(false);
}

///////////////////////////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////////////////////////////
/*
bool AllowTradesByTime()
{
   int Current_Time = TimeHour(TimeCurrent());
   if (Start_Time == 0) Start_Time = 24; 
   if (Finish_Time == 0) Finish_Time = 24; 
   if (Current_Time == 0) Current_Time = 24;
      
   if ( Start_Time < Finish_Time )
      if ( (Current_Time < Start_Time) || (Current_Time >= Finish_Time) ) return(false);
      
   if ( Start_Time > Finish_Time )
      if ( (Current_Time < Start_Time) && (Current_Time >= Finish_Time) ) return(false);
      
   return(0);
}
*/

